import asyncio
import os
import subprocess

custom_env = os.environ.copy()
display_number = 99
display_number_id = f":{display_number}"
custom_env["DISPLAY"] = str(display_number_id)


def non_block_init(username):
    """usermod -aG audio solomin."""
    stop_all_processes()
    subprocess.run(["usermod", "-aG", "audio", username])  # let user use sound card


def start_xvfb(username, width, height, depth):
    """1280x1024x24."""
    subprocess.run(
        ["sudo", "-u", username, "Xvfb", f"{display_number_id}", "-screen", "0", f"{width}x{height}x{depth}"]
    )
    print("!!! start_xvfb finished")  # noqa: T201


def start_desktop(username, desktop):
    run_data = ["sudo", "-u", username, desktop]
    if desktop == "fly-wm":
        run_data.append("--noparse")

    subprocess.run(run_data, env=custom_env)
    print("!!! start_desktop finished")  # noqa: T201


def start_glint(username):
    """/home/astravdi/freerdp/server/shadow/glint-server"""
    subprocess.run(["sudo", "-u", username, "glint-server"], env=custom_env)
    print("!!! start_glint finished")  # noqa: T201


def start_pulseaudio(username):
    subprocess.run(["sudo", "-u", username, "pulseaudio"])
    print("!!! start_pulseaudio finished")  # noqa: T201


def stop_all_processes():
    subprocess.run(["pkill", "-9", "-f", "Xvfb"])
    subprocess.run(["pkill", "-9", "-f", "glint-server"])
    try:
        os.remove(f"/tmp/.X11-unix/X{display_number}")
        os.remove(f"/tmp/.X{display_number}-lock")
    except FileNotFoundError:
        pass


async def stop_all_processes_delayed():
    print("!!! stop_all_processes_delayed started")  # noqa: T201
    await asyncio.sleep(10)
    stop_all_processes()
    print("!!! stop_all_processes_delayed finished")  # noqa: T201
